program schiffe;

{$M 8192,0,655360}
uses crt,dos,graph,drivers,intuit,timer;

const titel='        Schiffe versenken         -   uja Vers.1.000             TP6.01';
      dx=24; dy=24; ox=12; oy=24; xmax=10; ymax=10;
      up=#72; dn=#80; re=#77; li=#75;
      imafil='schiffe.ima';
      pal:array[0..15,0..2] of word=(
         ( 0, 0, 0),( 0, 0,42),( 0,27, 0),(49,55,55),
         (42, 5, 0),( 0,24,23),(30, 0, 0),(44,39,35),
         (21,21,21),(21,21,63),(21,63,21),(21,63,63),
         (63,27,11),(59,52,51),(63,46, 0),(61,58,56));

type feld=array[0..xmax+1,0..ymax+1] of integer;
     iarray=array[1..2] of integer;

var ok,ende,fertig     :boolean;
    itext1,itext2      :array[1..4] of Intuitext;
    ibord1,ibord2      :Border;
    xy,xy2             :Koords;
    igad               :array[1..4] of Gadget;
    ima                :array[1..8] of Image;
    f0,f1,f2           :feld;
    g,x,y,dran         :integer;
    count,punkte       :iarray;
    ch                 :char;

{ ------------------------------------------------------------------------ }
procedure delay(t:word);
begin
   delay1(t);
end;



procedure getimages;
var i:integer;
    anz:word;
    fh:file;
begin
   assign(fh,imafil);
   reset(fh,1);
   BlockRead(fh,ima[1],sizeof(image),anz);
   anz:=Imagesize(1,1,ima[1].width,ima[1].height);
   GetMem(ima[1].p_data,anz);
   BlockRead(fh,ima[1].p_data^,anz,anz);
   close(fh);
   putimage(0,0,ima[1].p_data^,normalput);
   freemem(ima[1].p_data,anz);
   for i:=1 to 8 do with ima[i] do begin
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      getimage(pred(i)*width,0,pred(i*width),pred(height),p_data^);
   end;
end;

procedure setcolors;
var i:integer;
begin
for i:=0 to 15 do begin
   setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
   setpalette(i,i);
end;
end;

{ ------------------------------------------------------------------------ }

procedure intuikram;
var i:integer;
begin
   for i:=1 to 2 do with itext1[i] do begin
      x:=8; y:=5; fpen:=15; bpen:=7; p_nexttext:=addr(itext2[i]);
      case i of
      1: itext:=' Neu';
      2: itext:=' Quit';
      end;
   end;
   for i:=1 to 2 do with itext2[i] do begin
      x:=pred(itext1[i].x); y:=itext1[i].y; fpen:=0; bpen:=itext1[i].bpen;
      itext:=itext1[i].itext; p_nexttext:=nil;
   end;

   xy[0]:=0;  xy[1]:=0; xy[2]:=56;  xy[3]:=0; xy[4]:=56;
   xy[5]:=15; xy[6]:=0; xy[7]:=15;  xy[8]:=0; xy[9]:=0;
   xy2[0]:=0;  xy2[1]:=0; xy2[2]:=112; xy2[3]:=0; xy2[4]:=112;
   xy2[5]:=15; xy2[6]:=0; xy2[7]:=15;  xy2[8]:=0; xy2[9]:=0;
   with ibord1 do begin
      x:=1; y:=1; fpen:=15; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=addr(ibord2);
   end;
   with ibord2 do begin
      x:=0; y:=0; fpen:=0; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;

{ neu, quit: }
   for i:=1 to 2 do with igad[i] do begin
      id:=i;
      x:=520+pred(i)*56;
      y:=460;
      width:=56;
      height:=16;
      bpen:=7;
      hibpen:=bpen;
      p_loborder:=addr(ibord1);
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;

{ Schifferfeld: }
  i:=3;
  with igad[i] do begin
      id:=i;
      x:=dx+ox;
      y:=oy+dy;
      width:=xmax*dx;
      height:=ymax*dy;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[4]);
   end;

  i:=4;
  with igad[i] do begin
      id:=i;
      x:=xmax*dx+ox;
      y:=oy+dy*(ymax+3);
      width:=dx;
      height:=dy;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=addr(ima[8]);
      p_hiimage:=addr(ima[7]);
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=nil;
   end;
end;

{ ------------------------------------------------------------------------ }

procedure darken;
var i:integer;
begin
for i:=1 to 15 do setpalette(i,0);
end;

procedure lighten;
var i:integer;
begin
for i:=1 to 15 do setpalette(i,i);
end;


procedure showelement(x,y,nr,dran:integer);
begin
   putimage(320*pred(dran)+x*dx+ox,y*dy+oy,ima[nr].p_data^,normalput);
end;


procedure spaltemarkieren(nr:integer);
begin
   rectfill(ox+dx,succ(ymax)*dy+oy,
            pred(ox+succ(xmax)*dx),pred((ymax+2)*dy+oy),1);
   putimage(nr*dx+ox,succ(ymax)*dy+oy,ima[8].p_data^,normalput);
end;

procedure zeilemarkieren(nr:integer);
begin
   rectfill(ox,dy+oy,
            pred(ox+dx),pred((ymax+1)*dy+oy),1);
   putimage(ox,nr*dy+oy,ima[7].p_data^,normalput);
end;

procedure messi(t:string);
begin
   rectfill(ox+dx,oy+(ymax+3)*dy,ox+xmax*dx,oy+(ymax+4)*dy,1);
   setcolor(11); outtextxy(ox+dx,oy+(ymax+3)*dy+8,t);
   setcolor(3); outtextxy(ox+dx,oy+(ymax+3)*dy+8,t);
end;




procedure buildscreen;
var i,j:integer;
begin
rectfill(0,0,639,479,1);
rectfill(0,0,639,14,7);
setcolor(0); line(0,15,639,15);
setcolor(15); outtextxy(9,4,titel);
setcolor(0); outtextxy(8,4,titel);
refreshgadgets(addr(igad[1]));
setcolors;
end;

procedure setzen(nr:integer; var ok:boolean);
 procedure checken(x,y,nr:integer; ri:boolean);
 var i:integer;
 begin
    ok:=f2[x,y]=0;
    case nr of
    1: begin
          f2[x,y]:=nr;
          showelement(x,y,nr+3,1);
       end;
    2: begin
          if ri then begin
             ok:=ok and (f2[x+1,y]=0);
             if ok then for i:=x to x+1 do begin
                f2[i,y]:=nr;
                showelement(i,y,nr+3,1);
             end;
          end else begin
             ok:=ok and (f2[x,y+1]=0);
             if ok then for i:=y to y+1 do begin
                f2[x,i]:=nr;
                showelement(x,i,nr+3,1);
             end;
          end;
       end;
    3: begin
          if ri then begin
             ok:=ok and (f2[x+1,y]=0) and (f2[x-1,y]=0);
             if ok then for i:=x-1 to x+1 do begin
                f2[i,y]:=nr;
                showelement(i,y,nr+3,1);
             end;
          end else begin
             ok:=ok and (f2[x,y+1]=0) and (f2[x,y-1]=0);
             if ok then for i:=y-1 to y+1 do begin
                f2[x,i]:=nr;
                showelement(x,i,nr+3,1);
             end;
          end;
       end;
    end;
 end;


begin
   showmouse;
   delay(50);
   hidemouse;
   if keypressed then begin
      ch:=upcase(readkey);
      case ch of
      #0      : begin
                   ch:=readkey;
                   case ch of
                   re: if x<xmax then begin
                           inc(x);
                           spaltemarkieren(x);
                        end;
                   li: if x>1 then begin
                           dec(x);
                           spaltemarkieren(x);
                        end;
                   up: if y>1 then begin
                           dec(y);
                           zeilemarkieren(y);
                        end;
                   dn: if y<ymax then begin
                           inc(y);
                           zeilemarkieren(y);
                        end;
                   end;
                end;
      #27,'Q' : ende:=true;
      #13 : checken(x,y,nr,igad[4].onoff);
      '0'..'9': begin
                   x:=ord(ch)-47;
                   spaltemarkieren(x);
                end;
      'A'..'J': begin  { reihe markieren }
                   y:=ord(ch)-64;
                   zeilemarkieren(y);
                end;
      #32: begin
             igad[4].onoff:=not igad[4].onoff;
             drawgadget(addr(igad[4]));
           end;

      end;
   end else begin
      getgadget(addr(igad[1]),g,x,y);
      case g of
      2: ende:=true;
      3: begin
            x:=(x-ox) div dx;
            y:=(y-oy) div dy;
            zeilemarkieren(y);
            spaltemarkieren(x);
            checken(x,y,nr,igad[4].onoff);
         end;
    4: begin
          igad[4].onoff:=not igad[4].onoff;
          drawgadget(addr(igad[4]));
        end;
      end;

   end;





end;






procedure newgame;
var i,j,k,l,ct:integer; ok:boolean;
begin
   rectfill(ox,oy,(xmax+2)*dx+320,(ymax+2)*dy,1);
   for i:=0 to xmax+1 do for j:=0 to ymax+1 do f0[i,j]:=9;
   for i:=1 to xmax do for j:=1 to ymax do f0[i,j]:=0;
   f2:=f0;
   randomize;
   { 3 Kreuzer setzen: }
   ct:=0;
   repeat
      k:=random(2);
      i:=random(xmax)+1;
      j:=random(ymax)+1;
      ok:=(f0[i,j]=0);
      if k<1 then begin
         ok:=ok and (f0[i-1,j]=0) and (f0[i+1,j]=0);
      end else begin
         ok:=ok and (f0[i,j-1]=0) and (f0[i,j+1]=0);
      end;
      if ok then begin
         if k<1 then for l:=i-1 to i+1 do f0[l,j]:=3
                else for l:=j-1 to j+1 do f0[i,l]:=3;
         inc(ct);
      end;
   until ct=3;

   { 4 Schoner setzen }
   ct:=0;
   repeat
      k:=random(2);
      i:=random(xmax)+1;
      j:=random(ymax)+1;
      ok:=(f0[i,j]=0);
      if k<1 then begin
         ok:=ok and (f0[i+1,j]=0);
      end else begin
         ok:=ok and (f0[i,j+1]=0);
      end;
      if ok then begin
         if k<1 then for l:=i to i+1 do f0[l,j]:=2
                else for l:=j to j+1 do f0[i,l]:=2;
         inc(ct);
      end;
   until ct=4;

   { 5 Mini-Boote setzen }
   ct:=0;
   repeat
      i:=random(xmax)+1;
      j:=random(ymax)+1;
      ok:=(f0[i,j]=0);
      if ok then begin
         f0[i,j]:=1;
         inc(ct);
      end;
   until ct=5;
   x:=5;
   y:=5;
   f1:=f0;
   for i:=1 to xmax do for j:=1 to ymax do showelement(i,j,1,1);
   zeilemarkieren(y);
   spaltemarkieren(x);

   ct:=0;
   l:=3;
   repeat
      ok:=false;
      messi('bitte Kreuzer setzen');
      setzen(l,ok);
      if ok then inc(ct);
   until (ct=3) or ende;
   ct:=0;
   l:=2;
   repeat
      ok:=false;
      messi('bitte Schoner setzen');
      setzen(l,ok);
      if ok then inc(ct);
   until (ct=4) or ende;
   ct:=0;
   l:=1;
   repeat
      ok:=false;
      messi('bitte Paddelboot setzen');
      setzen(l,ok);
      if ok then inc(ct);
   until (ct=5) or ende;
   dran:=1;
   for k:=1 to 2 do begin
      for i:=1 to xmax do for j:=1 to ymax do showelement(i,j,1,k);
      count[k]:=0;
      punkte[k]:=0;
   end;
end;


function finito(punkte:iarray):boolean;
begin
   finito:=(punkte[1]=22) or (punkte[2]=22);
end;

procedure schuss(x,y:integer; var dran:integer; var count,punkte:iarray; var f:feld);
var i,j,k:integer;
begin
if (x>0) and (x<=xmax) and (y>0) and (y<=ymax) then begin
   inc(count[dran]);
   case f[x,y] of
   0   : begin
            showelement(x,y,2,dran); f[x,y]:=8; dran:=succ(dran mod 2);
         end;
   1..3: begin
            for i:=1 to 5 do begin
               showelement(x,y,3,dran);
               delay(50);
               showelement(x,y,f[x,y]+3,dran);
               delay(25);
            end;
            inc(punkte[dran]);
            f[x,y]:=8+f[x,y];
         end;
   8   : dran:=succ(dran mod 2);
   end;
end;
end;



procedure compimove;
var ok:boolean;  i,j,x,y:integer;
begin
   randomize;
   x:=0; y:=0;
   { 3er suchen }
   for i:=1 to xmax do for j:=1 to ymax do if f2[i,j]=11 then begin
      if (f2[i-1,j]=11) and (f2[i+1,j]<8) then begin
         x:=i+1; y:=j;
      end;
      if (f2[i+1,j]=11) and (f2[i-1,j]<8) then begin
         x:=i-1; y:=j;
      end;
      if (f2[i,j-1]=11) and (f2[i,j+1]<8) then begin
         x:=i; y:=j+1;
      end;
      if (f2[i,j+1]=11) and (f2[i,j-1]<8) then begin
         x:=i; y:=j-1;
      end;

      if i>2 then if f2[i-2,j]=11 then if f2[i-1,j]<8 then begin
         x:=i-1; y:=j;
      end;
      if i<(xmax-1) then if f2[i+2,j]=11 then if  f2[i+1,j]<8 then begin
         x:=i+1; y:=j;
      end;
      if j>2 then if f2[i,j-2]=11 then if f2[i,j-1]<8 then begin
         x:=i; y:=j-1;
      end;
      if j<(ymax-1) then if f2[i,j+2]=11 then if  f2[i,j+1]<8 then begin
         x:=i; y:=j+1;
      end;


   end;
   if x=0 then { 2er suchen }
   for i:=1 to xmax do for j:=1 to ymax do
   if (f2[i,j]=10) or (f2[i,j]=11) then begin
      if f2[i-1,j]<8 then begin
         x:=i-1; y:=j;
      end;
      if (x=0) or (random(2)<1) then if f2[i+1,j]<8 then begin
         x:=i+1; y:=j;
      end;
      if (x=0) or (random(2)<1) then if f2[i,j-1]<8 then begin
         x:=i; y:=j-1;
      end;
      if (x=0) or (random(2)<1) then if f2[i,j+1]<8 then begin
         x:=i; y:=j+1;
      end;
   end;

   { random schuss }
   while x=0 do begin
      i:=succ(random(xmax)); j:=succ(random(ymax));
      if odd(i+j) then if random(5)<4 then inc(i);
      if f2[i,j]<8 then begin x:=i; y:=j; end;
   end;
   schuss(x,y,dran,count,punkte,f2);
end;



procedure aktion;
begin
   showmouse;
   delay(50);
   hidemouse;
   if keypressed then begin
      ch:=upcase(readkey);
      case ch of
      #0      : begin
                   ch:=readkey;
                   case ch of
                   re: if x<xmax then begin
                           inc(x);
                           spaltemarkieren(x);
                        end;
                   li: if x>1 then begin
                           dec(x);
                           spaltemarkieren(x);
                        end;
                   up: if y>1 then begin
                           dec(y);
                           zeilemarkieren(y);
                        end;
                   dn: if y<ymax then begin
                           inc(y);
                           zeilemarkieren(y);
                        end;
                   end;
                end;
      #27,'Q' : ende:=true;
      #13,#32 : schuss(x,y,dran,count,punkte,f1);
      '0'..'9': begin
                   x:=ord(ch)-47;
                   spaltemarkieren(x);
                end;
      'A'..'J': begin  { reihe markieren }
                   y:=ord(ch)-64;
                   zeilemarkieren(y);
                end;
      'N'     : newgame;
      end;
   end else begin
      getgadget(addr(igad[1]),g,x,y);
      case g of
      1: newgame;
      2: ende:=true;
      3: begin
            x:=(x-ox) div dx;
            y:=(y-oy) div dy;
            zeilemarkieren(y);
            spaltemarkieren(x);
            schuss(x,y,dran,count,punkte,f1);
         end;
      end;

   end;
end;



procedure spielergewonnen;
var i,j,k,l:integer;
begin
messi(' Du hast gewonnen!');
for k:=0 to 9 do begin
   if odd(k) then for i:=1 to xmax do for j:=1 to ymax do begin
      putimage(i*dx+ox,j*dy+oy,ima[3].p_data^,normalput);
   end;
   delay(75);
   if odd(k) then for i:=1 to xmax do for j:=1 to ymax do begin
      putimage(i*dx+ox,j*dy+oy,ima[1].p_data^,normalput);
   end;
   delay(25);
end;
end;

procedure compigewonnen;
var i,j,k:integer;
begin
messi('Ich habe gewonnen!');
for k:=0 to 9 do begin
   if odd(k) then for i:=1 to xmax do for j:=1 to ymax do begin
      putimage(i*dx+ox+320,j*dy+oy,ima[3].p_data^,normalput);
   end;
   delay(75);
   if odd(k) then for i:=1 to xmax do for j:=1 to ymax do begin
      putimage(i*dx+ox+320,j*dy+oy,ima[1].p_data^,normalput);
   end;
   delay(25);
end;
end;




begin
initscreen(ok);
if ok then begin
   getimages;
   intuikram;
   buildscreen;
   newgame;
   repeat
      if dran=1 then begin
         messi('Du bist dran:');
         aktion;
      end else begin
         messi ('Compi ist dran');
         compimove;
      end;
      if finito(punkte) then begin
         if punkte[1]=22 then spielergewonnen else compigewonnen;
         delay(1000);
         newgame;
      end;
   until ende;
end;
end.
